/*
** Copyright (C) 2020 Sylvain Fargier
**
** This software is provided 'as-is', without any express or implied
** warranty.  In no event will the authors be held liable for any damages
** arising from the use of this software.
**
** Permission is granted to anyone to use this software for any purpose,
** including commercial applications, and to alter it and redistribute it
** freely, subject to the following restrictions:
**
** 1. The origin of this software must not be misrepresented; you must not
**    claim that you wrote the original software. If you use this software
**    in a product, an acknowledgment in the product documentation would be
**    appreciated but is not required.
** 2. Altered source versions must be plainly marked as such, and must not be
**    misrepresented as being the original software.
** 3. This notice may not be removed or altered from any source distribution.
**
** Created on: 2021-12-30T17:07:25+01:00
**     Author: Sylvain Fargier <fargie_s> <fargier.sylvain@gmail.com>
**
*/

#ifndef LOGGER_HPP__
#define LOGGER_HPP__

#include <chrono>
#include <cstdint>
#include <ctime>
#include <functional>
#include <ios>
#include <memory>
#include <sstream>
#include <string>
#include <tuple>
#include <utility>

namespace logger {

class Logger;
class NullLogger;

/**
 * @brief available log levels
 * @details enabling a level also enables all lower levels
 */
enum class Level : uint8_t
{
    EMERG,
    ALERT,
    CRIT,
    ERROR,
    WARNING,
    NOTICE,
    INFO,
    DEBUG
};

/**
 * @brief logger features
 */
enum class Feature : uint8_t
{
    DATETIME = 0x01,  /**< display dateTime prefix */
    TIMEDELTA = 0x02, /**< display thread-based elapsed time since last log */
    LEVEL = 0x04,     /**< display level info */
    CATEGORY = 0x08,  /**< display category info */
    SYSLOG = 0x10,
    NOCOLOR = 0x20, /**< disable colored output (default: auto) */
    THREAD = 0x40 /**< display current thread id (id is generated by logger) */
};

/* UTILITIES */

/**
 * @brief utility class to log a time_point
 */
class LocalTime
{
public:
    typedef std::chrono::time_point<std::chrono::system_clock> time_point;

    explicit LocalTime(const time_point &time);
    LocalTime();

    const time_point time; /**< associated time-point */
};
std::string to_string(const LocalTime &time);

/**
 * @brief utility class to log elapsed time
 */
class Elapsed
{
public:
    Elapsed();

    /**
     * @brief ticking method
     * @details call this method forwarding its output to the logger to
     * tick the timer
     */
    std::chrono::milliseconds tick();

    std::chrono::time_point<std::chrono::steady_clock> start; /**< timer start
                                                                 point */
};

/**
 * @brief basic array iterator
 * @details also works on containers (to display part)
 * @details use iterator function to instantiate it
 * @details this class requires a LegacyForwardIterator
 */
template<typename T>
class Iterator
{
public:
    typedef typename std::decay<const T>::type Iter;

    constexpr Iterator(const Iter &begin, const Iter &end) :
        _begin(begin), _end(end)
    {}

    inline const Iter &begin() const { return _begin; }
    inline const Iter &end() const { return _end; }

    const Iter _begin;
    const Iter _end;
};

/**
 * @brief array iterator function
 * @details transforms basic array in range-iterable ones
 * @details this function requires a LegacyRandomAccessIterator
 * @param[in] begin start of array pointer or container iterator
 * @param[in] len number of elements to display
 */
template<typename T>
Iterator<T> iterator(const T &begin, std::size_t len)
{
    return Iterator<T>(begin, begin + len);
}

/**
 * @brief array iterator function
 * @details transforms basic array in range-iterable ones
 * @param[in] begin start of array pointer or iterator
 * @param[in] end end of array pointer or iterator
 */
template<typename T>
Iterator<T> iterator(const T &begin, const T &end)
{
    return Iterator<T>(begin, end);
}

/**
 * @brief main logger object
 */
class Logger
{
public:
    struct Writer;

    explicit Logger(Level level = Level::NOTICE,
                    Writer &writer = defaultWriter());
    ~Logger();
    Logger(const Logger &) = delete;
    Logger &operator=(const Logger &) = delete;
    Logger(Logger &&);

    inline const bool isEnabled() const { return !writer.buf.eof(); }

    /**
     * @brief Logger writer
     * @details generaly thread_local scoped
     */
    struct Writer
    {
        /** @brief log flusing and writing function */
        void flush(Level level);

        /** @brief log buffer preparation */
        void prepare(Level level);
        /** @brief get current log line */
        std::string str();

        std::stringstream buf; /**< log buffer, can be safely accessed */
        Elapsed last;          /**< time elapsed since last log line */

    protected:
        std::stringstream::pos_type prefixEnd; /**< end of "prepared" part */
    } & writer;
    const Level level; /**< level associated with this Logger */

    /**
     * @brief get default writer for current thread
     * @details mainly internally used
     */
    static Writer &defaultWriter();
};

/**
 * @brief external writer function type
 *
 * @param[in] level Level of line to print
 * @param[in] line '\n' terminated line to print
 */
typedef std::function<bool(Level level, const std::string &line)> write_func_t;

// clang-format off
// always resolve as "void"
template<class, class T> struct type_sink { typedef T type; };
template<class E, class T = void> using type_sink_t = typename type_sink<E, T>::type;

template<class T, class = void>
struct has_toString : std::false_type {};
template<class T>
struct has_toString<T, type_sink_t<decltype(std::declval<T>().toString())>> : std::true_type {};

template<class T, class = void>
struct has_to_string : std::false_type {};
template<class T>
struct has_to_string<T, type_sink_t<decltype(to_string(std::declval<T &>()))>> : std::true_type {};

/* Workarround for g++ 4.8.5 compiler, to explicitly exclude a type */
template<class T, class = std::true_type>
struct exclude_default : std::false_type {};

/* Warning: this is always true with g++ 4.8.5, due to bad template delcaration */
template<class T, class = void>
struct can_ostringstream : std::false_type {};
template<class T>
struct can_ostringstream<T, type_sink_t<decltype(std::declval<std::ostringstream>() << std::declval<T>())>> : std::true_type {};

template<class T, class = void>
struct has_mapped_type : std::false_type {};
template<class T>
struct has_mapped_type<T, type_sink_t<typename T::mapped_type>> : std::true_type {};

template<class T, class = void>
struct is_iterable_container : std::false_type {};
/* according to C++ spec anything that has begin/end can be iterated using range */
template<class T>
struct is_iterable_container<T, typename std::enable_if<
    !std::is_same<std::string, T>::value &&
    type_sink_t<decltype(std::declval<T>().begin()), std::true_type>::value &&
    type_sink_t<decltype(std::declval<T>().end()), std::true_type>::value>::type> : std::true_type {};
// clang-format on

/**
 * @brief general purpose logger operator
 */
template<typename T>
typename std::enable_if<!exclude_default<T>::value && can_ostringstream<T>::value &&
                            !is_iterable_container<T>::value &&
                            !has_toString<T>::value && !has_to_string<T>::value,
                        const Logger &>::type
    operator<<(const Logger &logger, const T &t)
{
    if (!logger.isEnabled())
        return logger;
    logger.writer.buf << t;
    return logger;
}

/**
 * @brief stl stream modifier logger operator
 * @details support std::endl and others
 */
template<typename CharT = char, typename Traits = std::char_traits<char>>
const Logger &operator<<(const Logger &logger,
                         std::basic_ostream<CharT, Traits> &(*pf)(
                             std::basic_ostream<CharT, Traits> &) )
{
    if (!logger.isEnabled())
        return logger;
    logger.writer.buf << pf;
    return logger;
}

/** @brief toString member logger operator */
template<typename T>
typename std::enable_if<!exclude_default<T>::value && has_toString<T>::value &&
                            !has_to_string<T>::value,
                        const Logger &>::type
    operator<<(const Logger &logger, const T &t)
{
    if (!logger.isEnabled())
        return logger;
    return (logger << t.toString());
}

/** @brief to_string function logger operator */
template<typename T>
typename std::enable_if<!exclude_default<T>::value && has_to_string<T>::value,
                        const Logger &>::type
    operator<<(const Logger &logger, const T &t)
{
    if (!logger.isEnabled())
        return logger;
    return (logger << to_string(t));
}

/**
 * @brief any duration logging
 * @details will be logged up to millisecond precision
 */
template<typename T, typename U>
typename std::enable_if<!exclude_default<std::chrono::duration<T, U>>::value,
                        const Logger &>::type
    operator<<(const Logger &logger, const std::chrono::duration<T, U> &ms)
{
    if (!logger.isEnabled())
        return logger;
    return (logger << std::chrono::duration_cast<std::chrono::milliseconds>(ms));
}

/**
 * @brief pair operator
 */
template<typename K, typename V>
typename std::enable_if<!exclude_default<std::pair<K, V>>::value,
                        const Logger &>::type
    operator<<(const Logger &logger, const std::pair<K, V> &pair)
{
    if (!logger.isEnabled())
        return logger;
    logger << pair.first << ":" << pair.second;
    return logger;
}

/**
 * @brief end of tuple operator
 */
template<size_t n, typename... T>
typename std::enable_if<!exclude_default<std::tuple<T...>>::value &&
                            (n >= sizeof...(T)),
                        const Logger &>::type
    operator<<(const Logger &logger, const std::tuple<T...> &)
{
    return logger;
}

/**
 * @brief tuple operator
 */
template<size_t n = 0, typename... T>
typename std::enable_if<!exclude_default<std::tuple<T...>>::value &&
                            (n < sizeof...(T)),
                        const Logger &>::type
    operator<<(const Logger &logger, const std::tuple<T...> &tup)
{
    if (!logger.isEnabled())
        return logger;
    if (n == 0)
        logger << "(";
    else
        logger << ",";
    logger << std::get<n>(tup);
    operator<< <n + 1>(logger, tup);
    if (n == 0)
        logger << ")";
    return logger;
}

constexpr std::size_t MAX_CONTAINER_ITEMS = 20;
constexpr std::ostringstream::off_type MAX_CONTAINER_LEN = 30;

/**
 * @brief stl containers support (any)
 * @details requirement is to be range-iterable and have value_type typedef
 * @details container is limited to 20 items or 30 characters on non-debug
 * loggers.
 */
template<typename T>
typename std::enable_if<!exclude_default<T>::value &&
                            is_iterable_container<T>::value &&
                            !has_toString<T>::value && !has_to_string<T>::value,
                        const Logger &>::type
    operator<<(const Logger &logger, const T &value)
{
    if (!logger.isEnabled())
        return logger;
    logger << (has_mapped_type<T>::value ? "{" : "[");
    std::size_t count = 0;
    const std::ostringstream::pos_type pos = logger.writer.buf.tellp();
    for (const auto &v : value)
    {
        if (count++)
            logger << ",";
        logger << v;
        if (logger.level != Level::DEBUG &&
            (count >= MAX_CONTAINER_ITEMS ||
             logger.writer.buf.tellp() >= (pos + MAX_CONTAINER_LEN)))
        {
            logger << "...";
            break;
        }
    }
    logger << (has_mapped_type<T>::value ? "}" : "]");
    return logger;
}

/**
 * @brief millisecond duration logging operator
 */
const Logger &operator<<(const Logger &logger,
                         const std::chrono::milliseconds &ms);

/**
 * @brief NullLogger discards everything
 */
class NullLogger : public Logger
{
public:
    explicit NullLogger(Level level);

    template<typename T>
    NullLogger &operator<<(T)
    {
        return *this;
    }
};

/**
 * @brief Configuration object
 * @details use this object to modify the logger behavior
 */
class Config
{
public:
    /**
     * @brief reset configuration and reload from env
     */
    Config &reset();

    /** @brief get current log level */
    Level getLevel() const;
    /** @brief set log level */
    Config &setLevel(Level level);

    /**
     * @brief clear and set category filter
     * @param filter filters to set
     * @details use an empty string to clear filters
     */
    Config &setFilter(const std::string &filter = std::string());
    /**
     * @brief add a new filter
     * @param filter filters to append
     * @details filters are appended to existing ones, being less prioritary
     */
    Config &addFilter(const std::string &filter);
    /** @brief get current filters */
    std::string getFilter() const;

    /** @brief enable a feature */
    Config &enable(Feature feature);
    /** @brief disable a feature */
    Config &disable(Feature feature);
    /** @brief check if a feature is enabled */
    bool isEnabled(Feature feature) const;

    /**
     * @brief Set the line writing function
     *
     * @param fun function pointer to set
     * @details the writer function must return `true` if the given line has
     * been consumed
     */
    Config &setWriteFunc(write_func_t fun);
};

/**
 * @brief reset stream flags to default value
 * @details use as: debug() << std::fixed << std::setprecision(42) << 1.23 <<
 * logger::clearflags;
 */
template<typename CharT, typename Traits>
std::basic_ostream<CharT, Traits> &clearflags(
    std::basic_ostream<CharT, Traits> &os)
{
    os.setf(std::ios_base::skipws | std::ios_base::dec,
            ~std::ios_base::fmtflags(0));
    os.width(0);
    os.precision(6);
    os.fill(os.widen(' '));
    return os;
}

/**
 * @brief create a Logger object
 * @param  level log level
 * @param  category associated category
 */
Logger log(Level level, const std::string &category = std::string());

#ifdef NDEBUG

inline NullLogger debug(const std::string & = std::string())
{
    return NullLogger(Level::DEBUG);
}

#else

/** @brief create a Level::DEBUG Logger */
inline Logger debug(const std::string &category = std::string())
{
    return log(Level::DEBUG, category);
}

#endif

/** @brief create a Level::INFO Logger */
inline Logger info(const std::string &category = std::string())
{
    return log(Level::INFO, category);
}

/** @brief create a Level::NOTICE Logger */
inline Logger notice(const std::string &category = std::string())
{
    return log(Level::NOTICE, category);
}

/** @brief create a Level::WARNING Logger */
inline Logger warning(const std::string &category = std::string())
{
    return log(Level::WARNING, category);
}

/** @brief create a Level::ERROR Logger */
inline Logger error(const std::string &category = std::string())
{
    return log(Level::ERROR, category);
}

/** @brief create a Level::CRIT Logger */
inline Logger crit(const std::string &category = std::string())
{
    return log(Level::CRIT, category);
}

/** @brief create a Level::ALERT Logger */
inline Logger alert(const std::string &category = std::string())
{
    return log(Level::ALERT, category);
}

/** @brief create a Level::EMERG Logger */
inline Logger emerg(const std::string &category = std::string())
{
    return log(Level::EMERG, category);
}

/**
 * @brief format any number as hex (first casted to unsigned)
 * @details use it along with `logger::hex`, ex: `logger::crit() <<
 * logger::hex(42)`
 * @details quite similar to `logger::crit() << std::hex << 42` but:
 * - will always pad depending on type width
 * - will not modify the stream's internal state (no `logger::clearflags`
 * required)
 * - will add a prefix (when requested)
 * - will support `uint8_t` and `int8_t` types (considered as `char` by regular
 * streams)
 */
template<typename T>
struct FmtHex
{
    constexpr FmtHex(const T &value, bool prefix = false) :
        value{value}, prefix{prefix}
    {}
    const T &value;
    const bool prefix;

    std::string toString() const
    {
        std::string str((sizeof(T) << 1) + (prefix ? 2 : 0), '0');
        std::string::reverse_iterator it{str.rbegin()};
        for (typename std::make_unsigned<T>::type temp =
                 static_cast<typename std::make_unsigned<T>::type>(value);
             temp != 0; temp = temp >> 4)
        {
            int8_t digit{static_cast<int8_t>(temp & 0x0F)};
            *it++ = (digit >= 10) ? (digit - 10 + 'A') : (digit + '0');
        }
        if (prefix)
            str[1] = 'x';
        return str;
    }
};

/**
 * @brief convenience function for FmtHex
 */
template<typename T>
inline const FmtHex<T> hex(const T &value, bool prefix = false)
{
    return FmtHex<T>(value, prefix);
}

/**
 * @brief optimization for FmtHex<uint8_t>
 */
inline const logger::Logger &operator<<(const logger::Logger &logger,
                                        const logger::FmtHex<uint8_t> &hex)
{
    if (logger.isEnabled())
    {
        if (hex.prefix)
            logger << "0x";
        int8_t digit = ((hex.value >> 4) & 0xF);
        logger << static_cast<char>((digit >= 10) ? (digit - 10 + 'A') :
                                                    (digit + '0'));
        digit = hex.value & 0xF;
        return logger << static_cast<char>((digit >= 10) ? (digit - 10 + 'A') :
                                                           (digit + '0'));
    }
    return logger;
}

template<typename T>
struct exclude_default<std::shared_ptr<T>> : std::true_type
{};

template<typename T>
struct exclude_default<std::unique_ptr<T>> : std::true_type
{};

template<typename T>
typename std::enable_if<
    std::is_same<std::unique_ptr<typename T::element_type>, T>::value ||
        std::is_same<std::shared_ptr<typename T::element_type>, T>::value,
    const logger::Logger &>::type
    operator<<(const logger::Logger &logger, const T &ptr)
{
    if (logger.isEnabled())
    {
        if (ptr)
            return logger << *ptr;
        else
            return logger << "nullptr";
    }
    return logger;
}

} // namespace logger

#endif
